//+------------------------------------------------------------------+
//|                                                   History_EA.mq4 |
//|                                                               Me |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Me"
#property link      ""
#property version   "1.00"
#property strict

extern double LotSize       =0.1;
extern int    MagicNumber   =198912;
extern int    MagicNumber_3_0=786;
extern int    MagicNumber_3_1=785;
extern int    TakeProfit_1  = 15;
extern int    TakeProfit_2  = 25;
extern int    TakeProfit_3  = 50;
extern int    StopLoss      = 100;   
extern double TrailingStart =10;
extern double TrailingStep  =2;
extern double TrailingStop  =6;
extern double BreakEvenStart=4;
extern double BreakEven     =1;
extern int    Slippage      =3;
extern double Value_Diff    = 0.0003;
extern int    Fast_MA_Value =14;
extern int    Slow_MA_Value =55;





int iOrderType_Buy  =0;
int iOrderType_Sell =1;
int BuyOrder;
int SellOrder;
int BuyOrder_1,BuyOrder_2, BuyOrder_3,BuyOrder_4 ;
int SellOrder_1, SellOrder_2, SellOrder_3,SellOrder_4;
double ticket_buy_3,ticket_sell_3;
int Buy_Ticket_3,Sell_Ticket_3,Buy_Ticket_4,Sell_Ticket_4;


int iOpenOrders_Sell;
int iOpenOrders_Buy;


int iLastError;


double dPip;
double dStopLossPrice, dTakeProfitPrice;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

if(Digits == 2 || Digits == 3){
	dPip = 0.01;
}else{
if(Digits == 4 || Digits == 5)
	dPip = 0.0001;
}

return(0);

}

int deinit()
{

Comment("");
return(0);

}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   double Fast_EMA, Slow_SMA, MA_Difference_1, MA_Difference_2;
//count open buy orders.
iOpenOrders_Buy = CntOrd(iOrderType_Buy,MagicNumber,Symbol());

//count open sell orders.
iOpenOrders_Sell = CntOrd(iOrderType_Sell,MagicNumber,Symbol());

Trailing_Stop(Symbol(), MagicNumber); 

Fast_EMA = iMA(NULL,0,Fast_MA_Value,0,MODE_EMA,PRICE_CLOSE,0);

Slow_SMA = iMA(NULL,0,Slow_MA_Value,0,MODE_SMA,PRICE_CLOSE,0);

MA_Difference_1= Fast_EMA-Slow_SMA;

MA_Difference_2= Slow_SMA-Fast_EMA;

//////////////////////////////////////////Checking for Buy Conditions//////////////////////////////
if (Fast_EMA>Slow_SMA)
 {
  if (MA_Difference_1>=Value_Diff && iOpenOrders_Buy ==0)
  {
  
   if(iOpenOrders_Sell > 0) 
   {
    bool bOrderClosed;
	  bOrderClosed = closeSellOrder(iOrderType_Sell); //Closing Sell order
		if(bOrderClosed)
		 {
		  Print("Sell Order Closed");
		 }
	else
		{ //order was not closed.
		 iLastError = GetLastError();
		}
	 }//End - Close open sell positions------------------------------------------
		
int ticketNumber=History_Calling(Symbol(), MagicNumber);

if(ticketNumber==Buy_Ticket_3 || ticketNumber==Buy_Ticket_4)
 {
  Print("The Buy Condition is Still Valid, so time to Open a Single Buy Order");
   One_Buy_Orders(LotSize,MagicNumber,TakeProfit_1,TakeProfit_2,TakeProfit_3,StopLoss,Slippage);
    Print("A Single Buy Order is Opened");
 }
 
if(ticketNumber==Sell_Ticket_3 || ticketNumber==Sell_Ticket_4)
  {
  Print("Last order was Sell and Now Buy condition is met, so time to Open a Three Buy Order");
   Three_Buy_Orders(LotSize ,MagicNumber,TakeProfit_1,TakeProfit_2,TakeProfit_3,StopLoss,Slippage);
    Print("Three Buy Orders are Opened");
  }
 }
}
////////////////////////Checking Sell Conditions//////////////////////////////////
if (Fast_EMA<Slow_SMA)
 {
  if (MA_Difference_2>=Value_Diff && iOpenOrders_Sell ==0)
   {
////////////////////////////////Closing Opened Buy Orders/////////////////////////   
    if(iOpenOrders_Buy > 0) 
     {
	   bool bOrderClosed;	
		 bOrderClosed = closeBuyOrder(iOrderType_Buy); //Closing Buy order	
		  if(bOrderClosed)
		   {
		    Print ("Opened Buy order got closed");
		   }
	  else
		 {
		  iLastError = GetLastError();
			Print("Error in closing Opened Buy Orders");	
		 }//end else if(bOrderClosed){
	}//end if(iOpenOrders_Buy > 0) {
	
	
int ticketNumber=History_Calling(Symbol(), MagicNumber);

if(ticketNumber==Sell_Ticket_3 || ticketNumber==Sell_Ticket_4)
 {
  Print("The Sell Condition is Still Valid, so time to Open a Single Sell Order");
   One_Sell_Orders(LotSize,MagicNumber,TakeProfit_1,TakeProfit_2,TakeProfit_3,StopLoss,Slippage);
    Print("A Single Sell Order is Opened");
 }
 
if(ticketNumber==Buy_Ticket_3 || ticketNumber==Buy_Ticket_4)
  {
   Print("Last order was Buy and Now Buy condition is met, so time to Open a Three Sell Order");
    Three_Sell_Orders(LotSize ,MagicNumber,TakeProfit_1,TakeProfit_2,TakeProfit_3,StopLoss,Slippage);
     Print("Three Sell Orders are Opened");
  }
 }
}
  
 return;
 } 
//+------------------------------------------------------------------+
void Three_Buy_Orders(double LotSize_3 ,int MagicNumber_3,int TakeProfit_1_3,int TakeProfit_2_3,int TakeProfit_3_3,int StopLoss_3,int Slippage_3 )
{		
	   double OpenPrice=Ask;
		int count=3;

		double  dTakeProfitPrice_1,dTakeProfitPrice_2,dTakeProfitPrice_3;
		dStopLossPrice = NormalizeDouble(OpenPrice - StopLoss * dPip,Digits);
	
		dTakeProfitPrice_1 = NormalizeDouble(OpenPrice + TakeProfit_1 * dPip,Digits);
		dTakeProfitPrice_2 = NormalizeDouble(OpenPrice + TakeProfit_2 * dPip,Digits);
		dTakeProfitPrice_3 = NormalizeDouble(OpenPrice + TakeProfit_3 * dPip,Digits);
		
iLastError = 0;
   if (count==3) 
    {
     BuyOrder_1=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_1, "Buy Order",MagicNumber, 0,Blue);
      if (BuyOrder_1>0) //Checking if the order was opened or not
       { 
        Print("Buy Order 1 Opened");
         count = count - 1; 
       }
     else 
       {
         iLastError = GetLastError();                               
          Print( "Error in Opening Buy Order 1");
       } 
     }

  if (count==2) 
    {
     BuyOrder_2=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_2, "Buy Order",MagicNumber, 0,Blue);
      if (BuyOrder_2>0) 
       { 
        Print ("Buy Order 2 Opened");
         count = count - 1; 
       }
     else 
      {
       iLastError = GetLastError();
        Print( "Error in Opening Buy Order 2");
      } 
    }

if (count==1) 
    {
     BuyOrder_3=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3, "BuyOrder_3",MagicNumber, 0,Blue);
 
    if (BuyOrder_3>0) 
      {
       Print("Last Buy Order was Opened, Ticket No:",BuyOrder_3 );
        Buy_Ticket_3=BuyOrder_3;
         count = count - 1; 
      }
     else
      {
       iLastError = GetLastError();                               
        Print( "Error in Opening Buy Order 3");
      }  
    }
return;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Three_Sell_Orders(double LotSize_3,int MagicNumber_3,int TakeProfit_1_3,int TakeProfit_2_3,int TakeProfit_3_3,int StopLoss_3,int Slippage_3 )
{

      double OpenPrice=Bid;
   	int count=3;	
      double dTakeProfitPrice_1,dTakeProfitPrice_2,dTakeProfitPrice_3;
		dStopLossPrice = NormalizeDouble(OpenPrice + StopLoss * dPip,Digits);
		
	   dTakeProfitPrice_1 = NormalizeDouble(OpenPrice - TakeProfit_1 * dPip,Digits);
		dTakeProfitPrice_2 = NormalizeDouble(OpenPrice - TakeProfit_2 * dPip,Digits);
		dTakeProfitPrice_3 = NormalizeDouble(OpenPrice - TakeProfit_3 * dPip,Digits);
		
iLastError = 0;
   if (count==3) 
    {
     SellOrder_1=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_1 , "Sell Order",MagicNumber, 0,Red);
		
    if (SellOrder_1>0) //Checking if the order was opened or not
      { 
       Print("Sell Order 1 Opened");
        count = count - 1; 
      }
     else 
     {
      iLastError = GetLastError();                               
       Print("Error in opening Sell order 1");
     } 
    }

  if (count==2) 
   {
    SellOrder_2=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_2 , "Sell Order",MagicNumber, 0,Red);
		
    if (SellOrder_2>0) //Checking if the order was opened or not
      { 
       Print("Sell Order 2 Opened");
       count = count - 1; 
      }
     else 
     {
      iLastError = GetLastError();                               
       Print("Error in opening Sell order 2");
     } 
   }

if (count==1) 
   {
    SellOrder_3=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice,dTakeProfitPrice_3 , "SellOrder_3",MagicNumber, 0,Red);
	
    if (SellOrder_3>0) //Checking if the order was opened or not
      { 
       Print("Last Sell Order was Opened, Ticket No:",SellOrder_3 );
       Sell_Ticket_3=SellOrder_3;
       count = count - 1; 
      }
     else 
     {
      iLastError = GetLastError();                               
       Print("Error in opening Sell order 3");
     } 
   }
return;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////
void One_Buy_Orders(double LotSize_3,int MagicNumber_3,int TakeProfit_1_3,int TakeProfit_2_3,int TakeProfit_3_3,int StopLoss_3,int Slippage_3 )
{
      double OpenPrice=Ask;
      iLastError = 0;
      int count=1;
		
		dStopLossPrice = NormalizeDouble(OpenPrice - StopLoss * dPip,Digits);
		double dTakeProfitPrice_3 = NormalizeDouble(OpenPrice + TakeProfit_3 * dPip,Digits);
      
      
      if(count==1)
      {
		 BuyOrder_4=OrderSend(Symbol(),0, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3, "Single Buy Order 4",MagicNumber, 0,Blue);
    
      if (BuyOrder_4>0) //Checking if the order was opened or not
       { 
        Print("Single Buy Order  Opened, Ticket No:",BuyOrder_4 );
         Buy_Ticket_4=BuyOrder_4;
          count=count-1;
       }
     else 
       {
        iLastError = GetLastError();                               
         Print( "Error in Opening Single Buy Order 4");
       }
      } 
return;
} 
////////////////////////////////////////////////////////////////////////////////////////////////////////////        
void One_Sell_Orders(double LotSize_3,int MagicNumber_3,int TakeProfit_1_3,int TakeProfit_2_3,int TakeProfit_3_3,int StopLoss_3,int Slippage_3 )
{
	
       double OpenPrice=Bid;
  	    int count=1;	
       iLastError = 0;
		 dStopLossPrice = NormalizeDouble(OpenPrice + StopLoss * dPip,Digits);
		 double dTakeProfitPrice_3 = NormalizeDouble(OpenPrice - TakeProfit_3 * dPip,Digits);
		
    if (count==1) 
     {
      SellOrder_4=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_3 , "Single Sell Order 4",MagicNumber, 0,Red);
		
    if (SellOrder_4>0) //Checking if the order was opened or not
      { 
       Print("Single Sell Order Opened, Ticket No:",SellOrder_4 );
        Sell_Ticket_4=SellOrder_4;
         count = count - 1; 
      }
     else 
      {
       iLastError = GetLastError();                               
        Print("Error in opening Single Sell order 4");
      } 
     }       
return;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
int CntOrd(int Type, int Magic, string Symb) {
//return number of orders matching the order type and symbol specific parameters. Magic number param is optional
int _CntOrd;
_CntOrd=0;
int iTotalOrders_;
iTotalOrders_ = OrdersTotal();

for(int i=iTotalOrders_;i>=0;i--)
{
   if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
 // Print("i=",i,"Symbol ", OrderSymbol(), " Order type= ", OrderType(), "Magic =", OrderMagicNumber()," ", Magic);
  
  
   if (OrderSymbol()==Symb) 
   {
    if ( OrderType()==Type && OrderMagicNumber()==Magic) _CntOrd++;
   }
  }
return(_CntOrd);
}//end int CntOrd(int Type, int Magic, string Symb) {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool closeBuyOrder(int iBuytype)
{
bool bClosed_;

if(OrdersTotal()>0)
 {
  for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
   {
    OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES);
     if(iBuytype==OP_BUY && OrderType()==OP_BUY)
      {
       if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         RefreshRates();
          bClosed_=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits), Slippage);
        }
      }
    }
  }

return(bClosed_);
}//end bool closeBuyOrder(int iBuytype)

//===========================================================================================

bool closeSellOrder(int iSelltype)
{
bool bClosed_;

	if(OrdersTotal()>0)
	{
		for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
		{
			if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES)) continue;

			if(iSelltype==OP_SELL && OrderType()==OP_SELL)
			 {
				if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
				 {
					RefreshRates(); 
					bClosed_ = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage);
				}//end if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
			}//end if(iSelltype==OP_SELL && OrderType()==OP_SELL)
		}//end for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
	}//end if(OrdersTotal()>0)
	
	
	return(bClosed_);
}//end bool closeSellOrder(int Selltype)
/////////////////////////////////////////////////////////////
void Trailing_Stop(string symbol, int magic)
           {
           double vPoint,vSlippage, ticket,New_SL; 
           ticket=0;
           if (Digits == 3 || Digits == 5)
            {vPoint = Point * 10; vSlippage = Slippage * 10;    }
            else
             {vPoint = Point; vSlippage = Slippage;}
            RefreshRates();          
                                   
            for ( int i=OrdersTotal()-1; i>=0; i--)    
            {
             if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
              {
                if(OrderSymbol()==symbol)
                 {
                   if(OrderMagicNumber()==magic)
                   {
                    if(OrderType()==OP_BUY)
                     {
                      if(OrderStopLoss()<OrderOpenPrice())
                      {
                       if(Bid>=OrderOpenPrice()+vPoint*BreakEvenStart)                         
                            {                             
                             ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+vPoint*BreakEven,OrderTakeProfit(),0,Green);
                              New_SL=OrderOpenPrice()+vPoint*BreakEven;
                               if (ticket > 0)
                                {
					                  Print ("Break Even Activated: ", OrderSymbol(), ": Modified SL", New_SL, ": Bid", Bid);					
					                 }
					                 else
					                 {
					                  iLastError = GetLastError();
				                 	  }
                               }
                              }                                            
                      else // if(OrderStopLoss()>OrderOpenPrice())
                       {
                        if(Bid-vPoint*TrailingStop>=OrderStopLoss())
                         {                         
                          ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()+vPoint*TrailingStep,OrderTakeProfit(),0,Green);
                            New_SL=OrderStopLoss()+vPoint*TrailingStep;
                             if (ticket > 0)
                              {
					                Print ("Trailed Stop Activated: ", OrderSymbol(), ": Modified SL", New_SL, ": Bid", Bid);					
					               }
					               else
					                {
					                 iLastError = GetLastError();
				                 	 }				                 	                             
                             }
                          }// End else
                       }//End if(OrderType()==OP_BUY)
                       
                       
                       if(OrderType()==OP_SELL)
                       {
                        if(OrderStopLoss()>OrderOpenPrice())
                         {
                           if(Ask<=OrderOpenPrice()-vPoint*BreakEvenStart)
                            {                             
                             ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-vPoint*BreakEven,OrderTakeProfit(),0,Green);
                              New_SL=OrderOpenPrice()-vPoint*BreakEven;
                               if (ticket > 0)
                                {
					                  Print ("Break Even Activated: ", OrderSymbol(), ": Modified SL", New_SL, ": Ask", Ask);					
					                 }
					               else
					                {
					                 iLastError = GetLastError();
				                 	 }		  
                             }
                          }
                          else
                          { 
                           if(Ask+vPoint*TrailingStop<=OrderStopLoss())
                            {
                              ticket=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-vPoint*TrailingStep,OrderTakeProfit(),0,Green);
                               New_SL=OrderStopLoss()-vPoint*TrailingStep;
                                if (ticket > 0)
                                 {
					                   Print ("Trailed Stop Activated: ", OrderSymbol(), ": Modified SL", New_SL, ": Ask", Ask);					
					                  }
					               else
					                {
					                 iLastError = GetLastError();
				                 	 }		                            
                            }
                           } //End else
                          }//if(OrderType()==OP_SELL)
                         }
                      }//End if(OrderSymbol()==symbol)
                     }//End if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
                    }//End for ( int i=OrdersTotal()-1; i>=0; i--)
                   }    
///////////////////////////////////////////////////////////////////////////////////
int History_Calling(string symbol,int magic)
{
int i=0;
int hstTotal=OrdersHistoryTotal();
int counter = 0;
int ticketNumber = 0; 
 for(i=0;i<hstTotal;i++)
    {
     if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
      if(OrderType() < 2)// this weeds out any pending orders.
       if(OrderSymbol()== symbol)
        if(OrderMagicNumber() == magic)
         if(OrderCloseTime() > counter)
           {
            counter=OrderCloseTime();    //each time it finds a greater closing time it
            ticketNumber = OrderTicket();//overwrites the counter and the ticket number. 
            Print("The Oder Ticket:",ticketNumber);   
           }
    }
     //now it has the ticket number of the highest closing time in seconds since 1970
     //you can get whatever info you want about that particular ticket.
     
    OrderSelect(ticketNumber,SELECT_BY_TICKET);// when you select by ticket you do not need to specify mode trades or mode history.
    int type = OrderType();// 0 is a buy and 1 is a sell
    string closeTime= TimeToString(OrderCloseTime());
    double closePrice = OrderClosePrice();     
    Print("Ticket number ",ticketNumber," of type ",type," was closed at ",closeTime," at a price of: ",closePrice);
    return(ticketNumber);

}
                    